#
# palette.make
#
# Variable definitions and rules for building palette projects.  A
# palette is a directory which contains a loadable executable and any resources
# that executable requires.  See wrapped.make for more information about
# projects whose product is a directory.
#
# PUBLIC TARGETS
#    palette: synonymous with all
#
# IMPORTED VARIABLES
#    none
#
# EXPORTED VARIABLES
#    none
#

.PHONY: palette all
palette: all

PRODUCT = $(PRODUCT_DIR)/$(NAME).palette
PRODUCTS = $(PRODUCT)
INNER_PRODUCT = $(PRODUCT)$(VERSION_SUFFIX)/$(NAME)$(DLL_EXT)
STRIPPED_PRODUCTS = $(INNER_PRODUCT)

PROJTYPE_MFLAGS = -F$(PRODUCT_DIR)
ifeq "$(OS)" "NEXTSTEP"
PROJTYPE_LDFLAGS = $($(OS)_PROJTYPE_LDFLAGS) -bundle -undefined suppress
else
PROJTYPE_LDFLAGS = $($(OS)_PROJTYPE_LDFLAGS) -bundle
endif


include $(MAKEFILEDIR)/wrapped-common.make
-include $(LOCAL_MAKEFILEDIR)/palette.make.preamble

$(PRODUCT): $(INNER_PRODUCT)

$(INNER_PRODUCT): $(DEPENDENCIES)
	$(SILENT) $(MKDIRS) $(PRODUCT)
	$(LD) $(ALL_LDFLAGS) $(ARCHITECTURE_FLAGS) -o $(INNER_PRODUCT) $(LOADABLES)

-include $(LOCAL_MAKEFILEDIR)/palette.make.postamble
