#
# tool.make
#
# Variable definitions and rules for building tool projects.  A tool is
# an executable file such as cc or ls.  Any resources required by the
# tool must be linked into the executable.
#
# PUBLIC TARGETS
#    tool: synonymous with all
#
# IMPORTED VARIABLES
#    none
#
# EXPORTED VARIABLES
#    none
#

.PHONY: tool all
tool: all
PROJTYPE = TOOL

PRODUCT = $(PRODUCT_DIR)/$(NAME)$(EXECUTABLE_EXT)
PRODUCTS = $(PRODUCT)
STRIPPED_PRODUCTS = $(PRODUCT)

include $(MAKEFILEDIR)/common.make
-include $(LOCAL_MAKEFILEDIR)/tool.make.preamble

$(PRODUCT): $(DEPENDENCIES)
	$(CC) -o $(PRODUCT) $(ALL_LDFLAGS) $(ARCHITECTURE_FLAGS) $(LOADABLES)

-include $(LOCAL_MAKEFILEDIR)/tool.make.postamble
