#
# nextstep-specific.make
#

OS_PREFIX = NEXTSTEP_

BE_PARANOID = YES

SHELL  = /bin/sh
CC = /bin/cc
FASTCP = /usr/lib/fastcp
CLONEHDRS = /usr/lib/clonehdrs
CHANGES = /usr/lib/changes
ARCH_TOOL = /usr/lib/arch_tool
OFILE_LIST_TOOL = /usr/lib/ofileListTool 
DEARCHIFY = $(ARCH_TOOL) -dearchify
ARCHIFY = $(ARCH_TOOL) -archify_list
CHOWN  = /usr/etc/chown -f
CHGRP  = /bin/chgrp -f
CHMOD  = /bin/chmod -f
TAR    = /usr/bin/gnutar

ifeq "$(LIBRARY_STYLE)" "STATIC"
LIBTOOL = /bin/libtool
else
LIBTOOL = $(CC) -dynamiclib
endif

STRIP  = /bin/strip
RM     = /bin/rm
SYMLINK = /bin/ln -s
CP     = /bin/cp
INSTALL = /usr/bin/install
INSTALL_HEADERS_CMD = $(CP) -p
ECHO   = echo
MKDIRS = /bin/mkdirs
TOUCH  = /usr/bin/touch
AWK    = /bin/awk
PSWRAP = /usr/bin/pswrap
MSGWRAP = /usr/bin/msgwrap -n
MIG    = /usr/bin/mig
RPCGEN = /usr/bin/rpcgen
FIXPRECOMPS = /usr/bin/fixPrecomps
LIPO = /bin/lipo
LN = $(SYMLINK)
MERGEINFO = /usr/lib/mergeInfo
VERS_STRING = /usr/bin/vers_string
ARCH_CMD = /usr/bin/arch
TRANSMOGRIFY = /bin/ln
SEARCH = /usr/bin/fgrep
FIND = /usr/bin/find
CAT = /bin/cat
MV = /bin/mv
TR = /usr/bin/tr
MKDIR = /bin/mkdir
SED = /bin/sed
LEX = /usr/bin/lex
YACC = /usr/bin/yacc
BASENAME = /usr/bin/basename

COMPILEHELP = /usr/bin/compileHelp

FRAMEWORK_TOOL = /usr/lib/frameworkFlags

BURY_STDERR = 2> /dev/null
DOTDOTIFY_PATH = $(SED) '/^[^/]/s:^:../:'
DOTDOTIFY_IPATHS = $(SED) 's:-I\.\./:-I../../:g'

NUMBER_OF_OBJECT_FILES = "`$(ECHO) $(OFILES) $(OTHER_OFILES) | wc -w`"

OBJCPLUS_FLAG = -ObjC++

PIPE_CFLAG = -pipe

# To handle workspace, which requires icons in sections:
PLATFORM_APP_LDFLAGS = $(APPICONFLAGS)

DYNAMIC_BUNDLE_UNDEFINED_FLAGS = -undefined suppress

DYNAMIC_CODE_GEN_CFLAG = -dynamic
STATIC_CODE_GEN_CFLAG = -static
DYNAMIC_LIBTOOL_FLAGS = -dynamic -install_name $(DYLIB_INSTALL_DIR)/$(DYLIB_INSTALL_NAME)
STATIC_LIBTOOL_FLAGS = -static

DYNALIB_EXT = .dylib
STATICLIB_EXT = .a
LIBRARY_PREF = lib
BUNDLE_BINARY_EXT =

# Default strip options
DYLD_EXEC_STRIP_OPTS = -S
APP_STRIP_OPTS = $(DYLD_EXEC_STRIP_OPTS)
TOOL_STRIP_OPTS =  $(DYLD_EXEC_STRIP_OPTS) 
LIBRARY_STRIP_OPTS = -S   # Note: -S strips debugging symbols
LIBRARY_INSTALL_OPTS = -sS 
DYNAMIC_STRIP_OPTS = -S

# Defaults for who to chown executables to when installing
INSTALL_AS_USER = root
INSTALL_AS_GROUP = wheel
