/*
	ClientInputManager.h
	Application Kit, Release 2.1J
  	Copyright 1990, 1991 Canon, Inc.
*/

#ifdef KANJI

#import <objc/Object.h>
#import <dpsclient/dpsclient.h>

//	mouse-click-part
#define FRONTHALF		0x0
#define BACKHALF		0x1

//	input-support-level
#define IM_NOSUPPORT			0x0
#define IM_WINDOWINPUT			0x1
#define IM_INLINEINPUT			0x2
#define IM_COLORINLINEINPUT		0x3

#define IM_COLOREDINLINEINPUT		0x3	// for backward compatibility

//	character-attribute
#define	IM_NOATTRIBUTE	0x0
#define	IM_UNDERLINE		0x1
#define	IM_HIGHLIGHT		0x2

//	Default database parameter for port name used to communicate with an 
//	input manager
#define IM_PORTNAMEENTRY	"InputManager"

typedef struct _IMStartKey {
	unsigned short	code;
	int				flags;
} IMStartKey;

@interface ClientInputManager:Object
{
	id				delegate;
	char				*imPortName;

	id				_support; // 	_IMIpcHandler
	int				_ctxt;	// 	contextNum
	id				_responder;	//	first-responder
	int				_displaySupportLevel;
	
	IMStartKey		*_startKeys;
	int				_keyCount;
	
	int				_return_int;	
	void				*_return_ptr;
	
	struct {
		unsigned int        getCmdKey			:1;
		unsigned int        imOn				:1;
		unsigned int        autoConnect		:1;
		unsigned int        _connectable		:1;
		unsigned int        _connected			:1;
		unsigned int        _displayDidCheck	:1;
		unsigned int        _canDisplay		:1;
		unsigned int        _setDeadKeyFlag	:1;
	}                   		_flags;

	int			_enableDeadKeys;
	int			_count;
}

- init;
- (const char *)imPortName;
- setIMPortName:(const char *)name;
- free;
- setDelegate:obj;
- delegate;
- setAutoConnect:(BOOL)flag;
- imGetCommandKeyFirst:(BOOL)flag;
- (int)imReturnINT;
- imReturnID;
- (BOOL)imReturnBOOL;
- (const char *)imReturnSTR;
- (void *)imReturnPTR;

- (int)imSendMessage: (SEL)selector, ...;
- (int)imSendRecMessage: (SEL)selector, ...;

@end

@interface ClientInputManager(CimInterface)

- imBeginSession;
- imEndSession;
- imProcessEvent:(NXEvent *)anEvent from:sender;

- (int)imNotifyResponderWillChange;
- (int)imNotifyResponderDidChange:(int)supportLevel;
- (int)imNotifyActivated;
- (int)imNotifyDeactivated;

- imAppDidBecomeActive;
- imAppDidResignActive;
- imKeyWindowWillChange:sender;
- imKeyWindowDidChange:sender;
- imFirstResponderWillChange:sender;
- imFirstResponderDidChange:sender;
- imTrapMouseAction:target;

- imCancelInput;
- imSendInput;
- imInsertionWillChange:sender;
- imMouseDownAt:(int)pos :(int)part clickCount:(int)count keyState:(int)flag;
- imMouseDraggedAt:(int)pos :(int)part keyState:(int)flag;
- imMouseUpAt:(int)pos :(int)part clickCount:(int)count keyState:(int)flag;
- (BOOL)imIsCommunicating;
- (const char *)imCurrentInputMode;
- (const char *)imName;
- (const char *)imVersion;
- imResponderDidFree:sender;

@end

#endif
