typedef enum {
	/* no error */
	NX_RTFDErrorNone = 0,
	/* writing errors */
	NX_RTFDErrorSaveAborted,
	NX_RTFDErrorUnableToWriteFile,
	NX_RTFDErrorUnableToCloseFile,
	NX_RTFDErrorUnableToCreatePackage,
	NX_RTFDErrorUnableToCreateBackup,
	NX_RTFDErrorUnableToDeleteBackup,
	NX_RTFDErrorUnableToDeleteTemp,
	NX_RTFDErrorUnableToDeleteOriginal,
	
	/* reading errors */
	NX_RTFDErrorFileDoesntExist,
	NX_RTFDErrorUnableToReadFile,
	
	/* both read and write */
	NX_RTFDErrorInsufficientAccess,
	NX_RTFDErrorMalformedRTFD
} NXRTFDError;

@protocol NXRTFDErrorHandler
- (BOOL) attemptOverwrite:(const char *)file;
 /* this message is sent to the error handler when the user does not have
    write access to the destination .rtfd file */
@end

