/*
	SliderCell.h
	Application Kit, Release 2.0
	Copyright (c) 1988, 1989, 1990, NeXT, Inc.  All rights reserved. 
*/

#import "ActionCell.h"

@interface SliderCell : ActionCell
{
    void *              _scPrivate;
    int                 _scPrivate1;
    int                 _scPrivate2;
    double              value;
    double              maxValue;
    double              minValue;
    NXRect              trackRect;
}


+ (BOOL)prefersTrackingUntilMouseUp;

- init;
- awake;

- (double)minValue;
- setMinValue:(double)aDouble;
- (double)maxValue;
- setMaxValue:(double)aDouble;
- setAltIncrementValue:(double)incValue;
- (double)altIncrementValue;
- (int)isVertical;
- (const char *)stringValue;
- setStringValue:(const char *)aString;
- (int)intValue;
- setIntValue:(int)anInt;
- (float)floatValue;
- setFloatValue:(float)aFloat;
- (double)doubleValue;
- setDoubleValue:(double)aDouble;
- setContinuous:(BOOL)flag;
- (BOOL)isContinuous;
- (BOOL)isOpaque;
- calcCellSize:(NXSize *)theSize inRect:(const NXRect *)aRect;
- setTitleGray:(float)grayVal;
- (float)titleGray;
- setTitleColor:(NXColor)newColor;
- (NXColor)titleColor;
- setTitleFont:fontObj;
- titleFont;
- (const char *)title;
- setTitle:(const char *)aString;
- setTitleNoCopy:(const char *)aString;
- setTitleCell:aCell;
- titleCell;
- setEnabled:(BOOL)flag;
- setKnobThickness:(NXCoord)aFloat;
- (NXCoord)knobThickness;
- setImage:backgroundImage;
- image;
- getKnobRect:(NXRect*)knobRect flipped:(BOOL)flipped;
- drawKnob:(const NXRect*)knobRect;
- drawKnob;
- drawBarInside:(const NXRect *)aRect flipped:(BOOL)flipped;
- drawSelf:(const NXRect *)cellFrame inView:controlView;
- drawInside:(const NXRect *)cellFrame inView:controlView;
- (BOOL)startTrackingAt:(const NXPoint *)startPoint inView:controlView;
- (BOOL)continueTracking:(const NXPoint *)lastPoint at:(const NXPoint *)currentPoint inView:controlView;
- stopTracking:(const NXPoint *)lastPoint at:(const NXPoint *)stopPoint inView:controlView mouseIsUp:(BOOL)flag;
- (BOOL)trackMouse:(NXEvent *)theEvent inRect:(const NXRect *)cellFrame ofView:controlView;
- write:(NXTypedStream *)stream;
- read:(NXTypedStream *)stream;

/* 
 * The following new... methods are now obsolete.  They remain in this  
 * interface file for backward compatibility only.  Use Object's alloc method  
 * and the init... methods defined in this class instead.
 */
+ new;

@end
